`timescale 1ns/1ps
`ifdef GATE_SIM
`define CYCLE 26.92
`else
`define CYCLE 30
`endif

module test;
        
        reg clock=0;
        reg reset=0;
        reg [15:0] port_in_data=0;
        reg sync=0;
        integer counter=0;

        wire [15:0] port_out_data;
	 wire [39:0] rom_data;
       wire [15:0] pc;

        always #(`CYCLE/2) clock=~clock;
        

        initial begin
		`ifdef GATE
			$dumpvars(1,test);
		`endif
                reset=1;
                #105;
                reset=0;
                #500000;
                $finish;
        end

        always @(negedge clock) begin
                counter=counter+1;
                if(counter>50)
                begin
                        sync = 1;
                        @(negedge clock);
                        sync = 0;
			counter = 0;
                end
        end

/*
        always @(negedge clock) begin
                port_in_data <= port_out_data;
        end
*/

        cpu cpu(.clock,.reset,.sync,.port_in_data(port_in_data),.port_out_data,.pc(pc),.rom_data(rom_data));

endmodule